diff --git a/drivers/net/cnxk/cn10k_ethdev_mtr.c b/drivers/net/cnxk/cn10k_ethdev_mtr.c
index 7273b88046..dbf74249c7 100644
--- a/drivers/net/cnxk/cn10k_ethdev_mtr.c
+++ b/drivers/net/cnxk/cn10k_ethdev_mtr.c
@@ -37,6 +37,18 @@ static struct rte_mtr_capabilities mtr_capa = {
 		      RTE_MTR_STATS_N_BYTES_YELLOW | RTE_MTR_STATS_N_BYTES_RED |
 		      RTE_MTR_STATS_N_BYTES_DROPPED};
 
+static struct cn10k_flow_meter *
+nix_mtr_find(struct cnxk_eth_dev *dev, uint32_t meter_id)
+{
+	struct cn10k_mtr *fms = &dev->mtr;
+	struct cn10k_flow_meter *fm;
+
+	TAILQ_FOREACH(fm, fms, next)
+		if (meter_id == fm->id)
+			return fm;
+	return NULL;
+}
+
 static struct cn10k_flow_meter_profile *
 nix_mtr_profile_find(struct cnxk_eth_dev *dev, uint32_t profile_id)
 {
@@ -317,6 +329,68 @@ cn10k_nix_mtr_policy_delete(struct rte_eth_dev *eth_dev, uint32_t policy_id,
 	return 0;
 }
 
+static int
+cn10k_nix_mtr_create(struct rte_eth_dev *eth_dev, uint32_t mtr_id,
+		     struct rte_mtr_params *params, int shared,
+		     struct rte_mtr_error *error)
+{
+	struct cnxk_eth_dev *dev = cnxk_eth_pmd_priv(eth_dev);
+	struct cn10k_flow_meter_profile *profile;
+	struct cn10k_flow_meter_policy *policy;
+	struct cn10k_mtr *fm = &dev->mtr;
+	struct cn10k_flow_meter *mtr;
+
+	RTE_SET_USED(shared);
+
+	if (params == NULL)
+		return -rte_mtr_error_set(error, ENOENT,
+					  RTE_MTR_ERROR_TYPE_MTR_PARAMS, NULL,
+					  "Meter params are invalid.");
+
+	profile = nix_mtr_profile_find(dev, params->meter_profile_id);
+	if (profile == NULL)
+		return -rte_mtr_error_set(error, ENOENT,
+					  RTE_MTR_ERROR_TYPE_METER_PROFILE_ID,
+					  &params->meter_profile_id,
+					  "Meter profile is invalid.");
+
+	policy = nix_mtr_policy_find(dev, params->meter_policy_id);
+	if (policy == NULL)
+		return -rte_mtr_error_set(error, ENOENT,
+					  RTE_MTR_ERROR_TYPE_METER_POLICY_ID,
+					  &params->meter_policy_id,
+					  "Meter policy is invalid.");
+
+	mtr = nix_mtr_find(dev, mtr_id);
+	if (mtr == NULL) {
+		mtr = plt_zmalloc(sizeof(struct cn10k_flow_meter), ROC_ALIGN);
+		if (mtr == NULL) {
+			return -rte_mtr_error_set(error, ENOMEM,
+				RTE_MTR_ERROR_TYPE_UNSPECIFIED, NULL,
+				"Meter memory alloc failed.");
+		} else {
+			mtr->id = mtr_id;
+			mtr->profile = profile;
+			mtr->policy = policy;
+			mtr->params = *params;
+			mtr->bpf_id = ROC_NIX_BPF_ID_INVALID;
+			mtr->prev_id = ROC_NIX_BPF_ID_INVALID;
+			mtr->next_id = ROC_NIX_BPF_ID_INVALID;
+			mtr->is_prev = false;
+			mtr->is_next = false;
+			mtr->level = ROC_NIX_BPF_LEVEL_IDX_INVALID;
+		}
+	} else {
+		plt_info("Meter already exist");
+		return 0;
+	}
+
+	profile->ref_cnt++;
+	policy->ref_cnt++;
+	TAILQ_INSERT_TAIL(fm, mtr, next);
+	return 0;
+}
+
 const struct rte_mtr_ops nix_mtr_ops = {
 	.capabilities_get = cn10k_nix_mtr_capabilities_get,
 	.meter_profile_add = cn10k_nix_mtr_profile_add,
@@ -324,6 +398,7 @@ const struct rte_mtr_ops nix_mtr_ops = {
 	.meter_policy_validate = cn10k_nix_mtr_policy_validate,
 	.meter_policy_add = cn10k_nix_mtr_policy_add,
 	.meter_policy_delete = cn10k_nix_mtr_policy_delete,
+	.create = cn10k_nix_mtr_create,
 };
 
 int
diff --git a/drivers/net/cnxk/cnxk_ethdev.h b/drivers/net/cnxk/cnxk_ethdev.h
index 3811360b75..c8ddcab8f1 100644
--- a/drivers/net/cnxk/cnxk_ethdev.h
+++ b/drivers/net/cnxk/cnxk_ethdev.h
@@ -145,6 +145,24 @@ struct cnxk_timesync_info {
 	uint64_t *tx_tstamp;
 } __plt_cache_aligned;
 
+struct cn10k_flow_meter {
+	TAILQ_ENTRY(cn10k_flow_meter) next;
+	/**< Pointer to the next flow meter structure. */
+	uint32_t id; /**< Usr mtr id. */
+	struct cn10k_flow_meter_profile *profile;
+	struct cn10k_flow_meter_policy *policy;
+	uint32_t bpf_id; /**< Hw mtr id. */
+	uint32_t rq_num;
+	uint32_t *rq_id;
+	uint16_t level;
+	uint32_t prev_id; /**< Prev mtr id for chaining */
+	uint32_t next_id; /**< Next mtr id for chaining */
+	bool is_prev;
+	bool is_next;
+	struct rte_mtr_params params;
+	struct roc_nix_bpf_objs profs;
+	uint32_t ref_cnt;
+};
 
 struct cn10k_flow_meter_policy {
 	TAILQ_ENTRY(cn10k_flow_meter_policy) next;
@@ -164,6 +182,7 @@ struct cn10k_flow_meter_profile {
 
 TAILQ_HEAD(cn10k_mtr_profiles, cn10k_flow_meter_profile);
 TAILQ_HEAD(cn10k_mtr_policy, cn10k_flow_meter_policy);
+TAILQ_HEAD(cn10k_mtr, cn10k_flow_meter);
 
 struct cnxk_eth_dev {
 	/* ROC NIX */
@@ -235,6 +254,7 @@ struct cnxk_eth_dev {
 	/* Ingress policer */
 	struct cn10k_mtr_profiles mtr_profiles;
 	struct cn10k_mtr_policy mtr_policy;
+	struct cn10k_mtr mtr;
 
 	/* Rx burst for cleanup(Only Primary) */
 	eth_rx_burst_t rx_pkt_burst_no_offload;